<template>
    <div class="container">
        <div class="row">
            <div class="col-md-8 col-md-offset-2">
                <div class="panel panel-default">
                    <div class="panel-body">
                        <form action="#" method="POST">
                            <label>Todo</label>
                            <input type="text" v-model="newForm.todo">
                            <button type="button" v-if="editFlag" v-on:click="update">save</button>
                            <button type="button" v-else="" v-on:click="add">Add</button>
                        </form>
                        <p class="error" v-if="validation.todo">{{validation.todo[0]}}</p>
                    </div>
                </div>
                <div class="panel panel-default">
                    <div class="panel-heading">Todo List</div>
                    <div class="panel-body">
                        <table class="table">
                            <tr>
                                <th>No</th>
                                <th>Id</th>
                                <th>Todo</th>
                                <th>Action</th>
                            </tr>
                            <tr v-for="(todo,iterator) in todos">
                                <td>{{iterator + 1}}</td>
                                <td>{{todo.id}}</td>
                                <td>{{todo.todo}}</td>
                                <td>
                                    <button type="button"  v-on:click="edit(todo.id)">edit</button>
                                    <button type="button" v-on:click="deleteTodo(todo.id)">delete</button>
                                </td>
                            </tr>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>
<script>
    export default {
        data(){
            return {
                todos: [],
                newForm: {
                    id:'',
                    todo : ''
                },
                validation:{},
                editFlag : false
            }
        },
        methods: {
            fetch: function () {
                let $this = this;
                axios.get('todo/list/data').then(function (response) { //pake function this e ilang gk iso dipake
                    console.dir(response);
                    $this.todos = response.data;
                }).catch(function (e) {
                    console.log(e);
                })
            },
            add: function () {
                axios.post('todo',this.newForm).then((res) => { // lek gk ono this e iso dipanggil
                    console.dir(res);
                    this.fetch();
                }).catch((e)=> {
                    console.dir(e);
                    this.validation = e.response.data;
                })
            },
            edit: function (id) {
                axios.get('todo/'+id+'/edit').then((response)=>{
                    console.dir(response.data);
                    this.newForm.todo =  response.data.todo;
                    this.newForm.id = response.data.id;
                    this.editFlag = true;
                })
            },
            update :function () {
                axios.put('todo/'+this.newForm.id,this.newForm).then((res)=>{
                    console.dir(res.data);
                    this.editFlag =false;
                    this.fetch();
                })
            },
            deleteTodo: function (id) {
                axios.delete('todo/' + id).then((res) => {
                    alert('deleted');
                    this.fetch();
                })
            }
        },
        mounted() {
            console.log('Component mounted.');
            let $this = this;
            $this.fetch();
        }
    }
</script>
